'use strict';

const Me = imports.misc.extensionUtils.getCurrentExtension();

const {GestureExtension} = Me.imports.src.gestures;
const {AltTabGestureExtension} = Me.imports.src.altTab;
const {OverviewRoundTripGestureExtension} = Me.imports.src.overviewRoundTrip;

class Extension {
	constructor() {
		this._extensions = [];
	}

	enable() {
		this._extensions = [
			new GestureExtension(),
			new AltTabGestureExtension(),
			new OverviewRoundTripGestureExtension()
		];
		this._extensions.forEach(extension => extension.enable());
	}

	disable() {
		for(let i=0; i<this._extensions.length; ++i) {
			this._extensions[i].disable();
			delete this._extensions[i];
		}
		this._extensions = [];
	}
};

function init() {
	return new Extension();
}
